-- thread for threadDemo5

require 'love.filesystem'
require 'love.image'
require 'love.timer'
require("love.graphics")
require("love.event")
require("love.mouse")
require("love.keyboard")

function load()
	bkgnd	= love.thread.getThread()
	event	= {
		load_image		= true,
		start_counter	= false,
		calc_fab 		= false
		}
	active	= true
	loadStatus()
	end

function update()
	if event.load_image		then load_image()	end
	if event.start_counter	then run_counter()	end
	if event.calc_fab		then calc_fab()		end-- Fibonacci sequence
	end

function load_image()
	bkgnd:set('image_acquiring',true)
	for i = 1, 3000 do	-- busy work!
		file = love.image.newImageData( 'love.png' )
		end
	bkgnd:set( 'image',				file	)
	bkgnd:set( 'image_loaded',		true	)
	bkgnd:set( 'image_acquiring',	false	)
	event.load_image	= false
	event.start_counter	= true
	end

function run_counter()
	bkgnd:set( 'counter_active', true )
	limit = bkgnd:peek( 'counter_limit' )
	time_start	= love.timer.getTime()
	counter 	= 0
	run_timer	= true
	while run_timer do
		time_change 	= love.timer.getTime() - time_start
		if time_change	> 1 then
			counter 	= counter + 1
			bkgnd:set( 'counter_value', counter )
			if counter 	== limit then run_timer = false end
			time_start 	= love.timer.getTime()
			end
		end
	bkgnd:set( 'counter_active', false )
	event.start_counter	= false
	event.calc_fab		= true
	end

function calc_fab()
	bkgnd:set( 'fab_calc',			true	)
	res = fib(37)
	bkgnd:set( 'fab_val',			res		)
	bkgnd:set( 'fab_ready',			true	)
	bkgnd:set( 'fab_calc',			false	)
	bkgnd:set( 'thread_running', 	false 	)
	calc_fab	= false
	active		= false		-- ends thread
	end

function fib(n) return n<2 and n or fib(n-1)+fib(n-2) end

function loadStatus()
	bkgnd:set( 'image_acquiring',	false	)
	bkgnd:set( 'image_loaded',		false	)
	bkgnd:set( 'counter_active',	false	)
	bkgnd:set( 'counter_value', 	0		)
	bkgnd:set( 'fab_calc',			false	)
	bkgnd:set( 'fab_ready',			false	)
	bkgnd:set( 'fab_val',			0		)
	bkgnd:set( 'thread_running',	true	)
	end

load()
while active do update() end



